#!/usr/bin/env bash

if ip address | grep -q 169.254.3.1
then
    echo "Redfish Host Interface has already been enabled."
    exit 0
fi

if ! $(dmesg | grep -q \'rndis_host\')
then
    "Redfish host interface not found, please check the support for the platfroms"
    exit 0
else 
    MAC=$(dmesg | grep \'rndis_host\' | tail -n 1)
    MAC_T=$(echo $MAC | rev | cut -d" " -f 1 | rev)
    INTERFACE=$(echo $MAC | awk '{if ($1=="[") print $5;else print $4}' | sed  's/://')

    for i in $(ls /sys/class/net)
    do
        MAC_C=$(cat /sys/class/net/$i/address)    
        if [[ "$i" == "$INTERFACE" ]] || [[ "$MAC_T" == "$MAC_C" ]]
        then
            ip link set dev $i up
            ip addr add 169.254.3.1/255.255.255.0 dev $i
            exit 0;
        fi
    done
     
    echo "RHI enable failed, please report the issue."
fi
